# RC5_empf_2a.py: Zeichenketten über IR-Modul im Manchestercode mit unbekannter halben Bitzeit T empfangen 
# vgl. auch Kommentar zu rc5_empf_1a.py 


from time import sleep, sleep_us, sleep_ms, ticks_us, ticks_diff
from machine import Pin, PWM

signal = Pin(25, Pin.IN) # für Empfangssignal

def wait_for_start_bit():
    while not signal.value():
        pass
    
def getBitzeitT():
    t0 = ticks_us()
    while signal.value():
        pass
    while not signal.value():
        pass
    return ticks_diff(ticks_us(), t0) // 2

def get_bit_list(n, t): # n = Anzahl der Bits, t = Zeit für 1 (ganzes) Bit
    global signal # ?
    l = []
    for i in range(n):
        l.append(signal.value())
        sleep_us(t)
    return l

def bit_list_to_nr(l): # Zahl
    n = len(l)
    value = l[0]
    for i in range(1, n):
        value = (value << 1) + l[i] # value = value * 2 + l[i]
    return value    

# Hauptprogramm

nr_of_bits = 8 # Hier werden also Bytes übertragen

print('Warte auf Botschaften...')

# Einzelne Bytes empfangen und auf dem Terminal ausgeben
while True:
    wait_for_start_bit() # jetzt in der Mitte des 2. Präambel-Bits
    T = getBitzeitT() # jetzt am Ende des 1. Präambel-Bits
    T_2 = T * 2
    T_2_2 = 2 * T + T // 2
    sleep_us(T_2_2) # jetzt in der Mitte der 2. Hälfte des 1. Payload-Bits (nr_of_startbits = 2)
    bit_list = get_bit_list(nr_of_bits, T_2)
    # print(bit_list) # zu Testzwecken
    value = bit_list_to_nr(bit_list)
    # print(value) # zu Testzwecken
    if nr_of_bits == 8:
        print(chr(value), end = '')
    sleep_us(T) # jetzt hinter dem letzten Bit
    
    
  