# RC5_send_1h: eine Zeichenkette (mit einer LED an Pin 25) im Manchestercode senden
# Präambel (zwei 1-Bits') und 
# Payload (1 Byte bzw. 8 Bits, 0/1 mit neg./pos. Flanke)
# Halbe Bit-Dauer: real: ca. T = 900 us, s. u.)
# getestet am 22.09.2014


from time import sleep, sleep_us, sleep_ms
from machine import Pin
led = Pin(25, Pin.OUT)

T = 890 # Halbe Bitzeit in us (ergibt real ca. 900 us)

def send_symbol(b): # sendet Signal für 1 Bit b; b ist 1 oder 0
    led.value(b == 0)
    sleep_us(T)
    led.value(b == 1)
    sleep_us(T)
    
def to_bitlist(anzahl_bits, n):   # anzahl_bits: Anzahl der Bits (bei der Übertragung eines Bytes: 8); n: Zahl (int), z. B. ASCII-Code eines Zeichens
    bl = []
    for i in range(anzahl_bits):
        j = anzahl_bits - 1 - i
        if n & (1 << j) : # n & (1 << j) > 0 => True
            bl.append(1)
        else:
            bl.append(0)
    # print(bl) # Zum Testen       
    return bl

def send_bitlist(b_l): # sendet die Signalfolge für die Bit-Liste bl
    for i in b_l:
        send_symbol(i)


# Eingabe der Zeichenkette:
zk = input('Text: ')
print('sende: ', zk)

led.value(0) # mit Low-Signal starten
sleep(2)     # hier ggf. Digital Analyser oder Empfangsprogramm starten

# Zeichenkette senden...
for c in zk:
    pre_list = [1,1] # Präambel
    ascii_code = ord(c)
    bit_list = to_bitlist(8, ascii_code) # Bitliste    
    # Präambel senden:
    send_bitlist(pre_list)
    # Bitliste für Zeichen senden:
    send_bitlist(bit_list)
    led.value(0) # mit Low-Signal beenden
    sleep_ms(40) # 20 zu klein!